-- Gradient Bars

--Define Properties
property("Gradient", GRADIENT, 0.0, 255, 128, 0, 0.5, 255, 255, 255, 1.0, 0, 192, 255)
property("Background",COLOUR,0,0,0)
property("Bands", INTEGER, 5, 1) -- Number of bands (default to 5)
property("Reverse", BOOLEAN, false)
property("Rotate", BOOLEAN, false)
property("Seed", INTEGER, 500, 0) -- Seed for random number generator (default to 500)

-- initialise the random number generator
math.randomseed(math.random(0,Seed))
band_angle = {}
band_max = 0
max = (math.floor(math.pi*200))

for i=0,Bands do
    band_angle[i] = math.random(1,max)/100
end

-- width of the bands in pixels
if Rotate then
    band_width = height/Bands
    band_max = width
else
    band_width = width/Bands
    band_max = height
end

-- the pixel function
function pixel(frame,x,y)
    if Rotate then
        x2=y
        y=x
        x=x2
    end
    -- get the band in which this pixel falls
    local band = math.floor(x/band_width)
    -- get the fraction through the effect
    local t = frame/frames
    -- get the height of the band in which this pixel falls
    -- local band_height = (math.sin((band/Bands+t)*math.pi*2)+1)/2
    local band_height = math.abs(math.sin(band_angle[band]+(t*(max/100))))-0.05
    -- print(band_height)
    -- decide if this pixel is inside the band
    if Reverse then
        if (math.abs(y)/(band_max) <= band_height) then
            return Background
        else
            return Gradient:lookup(y/(width-1))
        end
    else
        if (math.abs(y)/(band_max) <= band_height) then
            return Gradient:lookup(1-(y/(width-1)))
        else
            return Background
        end
    end
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]